import java.awt.geom.Point2D as Point2D
import java.awt.geom.Rectangle2D as Rectangle2D

import sys

from gvsiglib import *

mapContext = None

def getMapContext():
    view = gvSIG.getActiveDocument()
    if view == None:
      print "No se puede acceder al documento activo."
      return None
    try:
      mapContext = view.getModel().getMapContext()

    except Exception, e:
      print "El documento activo no parece ser una vista."
      print "Error %s %s" % (str(e.__class__),str(e))
      return None

    return mapContext

mapContext = getMapContext()

def clickAplicar(thinlet):

    global mapContext

    if mapContext == None:
      print "No se puede acceder al documento activo."
      return

    if mapContext.getLayers().getLayersCount() < 1:
      print "El documento activo no tiene capas disponibles."
      return
    x = float(thinlet.getString(txtX, "text"))
    y = float(thinlet.getString(txtY, "text"))
    center = zoomToCoordinates(mapContext, x,y)
    drawPoint(mapContext,center)

def zoomToCoordinates(mapContext, x,y):
  try:
    oldExtent = mapContext.getViewPort().getAdjustedExtent()
    oldCenterX = oldExtent.getCenterX()
    oldCenterY = oldExtent.getCenterY()
    center=Point2D.Double(x,y)
    movX = x-oldCenterX
    movY = y-oldCenterY
    upperLeftCornerX = oldExtent.getMinX()+movX
    upperLeftCornerY = oldExtent.getMinY()+movY
    width = oldExtent.getWidth()
    height = oldExtent.getHeight()
    extent = Rectangle2D.Double(upperLeftCornerX, upperLeftCornerY, width, height)
    mapContext.getViewPort().setExtent(extent)
    return center
  except ValueError, e:
    print "Se ha producido un error realizando zoom a las coordenadas (%s,%s). Error  %s, %s" % (
      repr(x),
      repr(y),
      str(e.__class__),
      str(e)
    )
    return None

def drawPoint(mapContext, center, color=None):
    """
    Esta funcin pintar un punto sobre la capa de grficos 
    asociada al mapContext.
    Todo mapContext adems de las capas que tenga cargadas dispone
    una capa graphics sobre la que dibujar elementos grficos.
    """

    if color == None:
        import java.awt.Color as Color
        color = Color.blue

    layer=mapContext.getGraphicsLayer()
    layer.clearAllGraphics()
    theSymbol = FSymbol(FConstant.SYMBOL_TYPE_POINT,color)
    idSymbol = layer.addSymbol(theSymbol)
    geom = ShapeFactory.createPoint2D(center.getX(),center.getY())
    theGraphic = FGraphic(geom, idSymbol)
    layer.addGraphic(theGraphic)

def activeDocumentIsAValidView():
    global mapContext
    
    if mapContext == None:
      print "El documento activo no parece ser una vista."
      return False
    
    if mapContext.getLayers().getLayersCount() < 1:
      print "El documento activo no tiene capas disponibles."
      return False
    return True

if activeDocumentIsAValidView():
  thinlet.setBoolean(botAplicar,"enabled",True)
else:
  thinlet.setBoolean(botAplicar,"enabled",False)
